//+------------------------------------------------------------------+
//|                                                  Break Arrow.mq4 |
//|                                            Copyright 2017, ODSEL |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, ODSEL"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 4

// ENUMS
enum pattern
  {
      ENGULF_OPEN_CLOSE =  0,
      TWIZZERS          =  1,
  };

enum direction
  {
      UPWARDS = 1,
      DOWNWARDS = -1,
  };

// EXTERS
extern string              MSG00             =  " ### MAIN SETTINGS ### ";
extern string              MSG000            =  " --- High Low Settings --- ";
extern int                 HL_Bars           =  20;            // Bars to consider 
extern string              MSG00001          =  " --- Candle count Settings --- ";
extern int                 BarsForwardOffset =  8;             // Bars forward offset (min 2)
extern int                 BarsAllowedFrom   =  0;             // Bars allowed from (0 - right from the beggining)
extern string              MSG00002          =  " --- Pattern Settings --- ";
extern pattern             PatternMode       =  1;             // Pattern Mode
       double              BorderAllowed     =  0;             // Allowed Border (0 no limit for border allowance)

extern string              MSG0001           =  " ### FILTERS SETTINGS ### ";
extern bool                Filters_Apply     =  true;          // Apply Filters
extern string              MSG0002           =  " --- RSI Paramenters --- ";
extern int                 RSI_Period        =  8;             // Period
extern ENUM_APPLIED_PRICE  RSI_Appliedprice  =  0;             // Applied to
extern double              RSI_Upper_level   =  53;            // RSI upper level
extern double              RSI_Lower_level   =  49;            // RSI lower level
extern int                 RSI_Shift         =  3;             // RSI shift
extern string              MSG00003          =  " --- STOCHASTIC Paramenters --- ";
extern int                 StochK            =  6;             // K
extern int                 StochD            =  3;             // D
extern int                 StochSlowing      =  3;             // Slowing
extern int                 StochMethod       =  1;             // Method
extern double              StochLevel        =  55;            // Stochastic upper level
extern double              StochLevel2       =  47;            // Stochastic lower level
extern int                 StochPriceField   =  1;             // Stochastic price field (0 - Low/High, 1 - Close/Close)
extern int                 STOCH_Shift       =  1;             // Stochastic bars back
extern string              MSG01             =  " ### LINES SETTINGS ### ";
extern bool                Draw_Lines        =  true;          // Draw actual lines
extern bool                Plot_Triangles    =  true;          // Plot Triangles
extern ENUM_LINE_STYLE     up_line_style     =  0;             // Up line style (0 - 4)
extern ENUM_LINE_STYLE     dw_line_style     =  0;             // Down line style (0 - 4)
extern int                 up_line_width     =  1;             // Up line width
extern int                 dw_line_width     =  1;             // Down line width
extern color               up_line_clr       =  clrGreen;      // Up line color
extern color               dw_line_clr       =  clrRed;        // Down line color

extern string              MSG02             =  " ### ARROW SETTINGS ### ";
extern bool                Draw_Arrows       =  true;          // Draw Arrows
extern int                 up_arrow_code     =  233;           // Up Arrow
extern int                 dw_arrow_code     =  234;           // Down Arrow
extern color               clr_arrow_up      =  clrSkyBlue;    // Up color
extern color               clr_arrow_down    =  clrOrangeRed;  // Down color
extern int                 up_arrow_width    =  1;             // Up width
extern int                 dw_arrow_width    =  1;             // Down width
extern int                 arrow_offset      =  20;            // Arrow offset in pips

extern string              MSG03             =  " ### ALERT SETTINGS ### ";
extern bool                EnableAlert       =  false;         // Enable Alerts
extern string              CallMSG           =  " CALL ";      // Call Message on Alert
extern string              PutMSG            =  " PUT ";       // Put Message on Alert

extern string              MSG04             =  " ### ITM RATIO DISPLAY SETTINGS ### ";
extern bool                Draw_ITM_Label    =  true;          // Draw ITM Ratio Info
extern bool                Calculate_History =  true;          // Calculate history
extern int                 info_corner       =  1;             // Corner [ 0 - 3 ]
extern int                 info_x            =  20;            // x offset
extern int                 info_y            =  60;            // y offset


// GLOBALS
double   UP_LINE[];
double   DOWN_LINE[];
double   UP_ARROW[];
double   DOWN_ARROW[];
bool     FILTER_ALLOW_BUY_CURRENT = false;
bool     FILTER_ALLOW_SELL_CURRENT = false;
bool     FILTER_ALLOW_BUY_PREVIOUS = false;
bool     FILTER_ALLOW_SELL_PREVIOUS = false;
int      TRIANGLE_UP_COUNTER = 0;
int      TRIANGLE_DW_COUNTER = 0;
double      ITM_1 = 0;
double      OTM_1 = 0;
double      ITM_2 = 0;
double      OTM_2 = 0;
double      ITM_3 = 0;
double      OTM_3 = 0;
double      ITM_4 = 0;
double      OTM_4 = 0;
double      ITM_5 = 0;
double      OTM_5 = 0;
double      ITM_6 = 0;
double      OTM_6 = 0;
double   ADX_VALUE;
double   RSI_0_0;
double   RSI_1_0;
double   STOCH_0_0;
double   RSI_0_1;
double   RSI_1_1;
double   STOCH_0_1;

int      BarsCount = 0;
int      BarsForITMS = 0;
string   PREFIX = "B_A_HL_v3.2";

datetime SETUP_TIME_UP;
double   SETUP_PRICE_DW;
datetime SETUP_TIME_DW;
double   SETUP_PRICE_UP;
double   PREVIOUS_SWING_UP;
double   PREVIOUS_SWING_DW;
int      BARS_TO_PREVIOUS_SWING_UP;
int      BARS_TO_PREVIOUS_SWING_DW;
datetime MEM_SETUP_TIME_UP;
datetime MEM_SETUP_TIME_DW;

bool runonce = true;
bool runonce_1 = true;

// INIT
int init()  
{
   IndicatorBuffers( 4 );
   SetIndexBuffer( 0, UP_LINE );
   SetIndexBuffer( 1, DOWN_LINE );
   SetIndexBuffer( 2, UP_ARROW );
   SetIndexBuffer( 3, DOWN_ARROW);
   SetIndexEmptyValue( 0, 0 );
   SetIndexEmptyValue( 1, 0 );
   SetIndexEmptyValue( 2, 0 );
   SetIndexEmptyValue( 3, 0 );
   
   if( Draw_Lines )
     {
         SetIndexStyle( 0, DRAW_LINE, 0, 2, clrDarkGreen );
         SetIndexStyle( 1, DRAW_LINE, 0, 2, clrOrangeRed );
     }
   else
     {
         SetIndexStyle( 0, DRAW_NONE );
         SetIndexStyle( 1, DRAW_NONE );
     }

   
   if( Draw_Arrows )
     {
         SetIndexStyle(2, DRAW_ARROW, EMPTY, up_arrow_width, clr_arrow_up);
         SetIndexArrow(2, up_arrow_code);
         
         SetIndexStyle(3, DRAW_ARROW, EMPTY, dw_arrow_width, clr_arrow_down);
         SetIndexArrow(3, dw_arrow_code);
     }
   else
     {
         SetIndexStyle( 2, DRAW_NONE );
         SetIndexStyle( 3, DRAW_NONE );
     }
   // labels
   if( Draw_ITM_Label )
     {

         ObjectCreate   (StringConcatenate(PREFIX, "ONE_BAR"),       OBJ_LABEL,        0, 0, 0  );
         ObjectSet      (StringConcatenate(PREFIX, "ONE_BAR"),       OBJPROP_CORNER,   info_corner    );
         ObjectSet      (StringConcatenate(PREFIX, "ONE_BAR"),       OBJPROP_XDISTANCE,info_x       );
         ObjectSet      (StringConcatenate(PREFIX, "ONE_BAR"),       OBJPROP_YDISTANCE,info_y       );

         ObjectCreate   (StringConcatenate(PREFIX, "TWO_BARS"),       OBJ_LABEL,        0, 0, 0  );
         ObjectSet      (StringConcatenate(PREFIX, "TWO_BARS"),       OBJPROP_CORNER,   info_corner    );
         ObjectSet      (StringConcatenate(PREFIX, "TWO_BARS"),       OBJPROP_XDISTANCE,info_x       );
         ObjectSet      (StringConcatenate(PREFIX, "TWO_BARS"),       OBJPROP_YDISTANCE,info_y + 20      );

         ObjectCreate   (StringConcatenate(PREFIX, "THREE_BARS"),       OBJ_LABEL,        0, 0, 0  );
         ObjectSet      (StringConcatenate(PREFIX, "THREE_BARS"),       OBJPROP_CORNER,   info_corner    );
         ObjectSet      (StringConcatenate(PREFIX, "THREE_BARS"),       OBJPROP_XDISTANCE,info_x       );
         ObjectSet      (StringConcatenate(PREFIX, "THREE_BARS"),       OBJPROP_YDISTANCE,info_y + 40      );
         
         ObjectCreate   (StringConcatenate(PREFIX, "FOUR_BARS"),       OBJ_LABEL,        0, 0, 0  );
         ObjectSet      (StringConcatenate(PREFIX, "FOUR_BARS"),       OBJPROP_CORNER,   info_corner    );
         ObjectSet      (StringConcatenate(PREFIX, "FOUR_BARS"),       OBJPROP_XDISTANCE,info_x       );
         ObjectSet      (StringConcatenate(PREFIX, "FOUR_BARS"),       OBJPROP_YDISTANCE,info_y + 60      );

         ObjectCreate   (StringConcatenate(PREFIX, "FIVE_BARS"),       OBJ_LABEL,        0, 0, 0  );
         ObjectSet      (StringConcatenate(PREFIX, "FIVE_BARS"),       OBJPROP_CORNER,   info_corner    );
         ObjectSet      (StringConcatenate(PREFIX, "FIVE_BARS"),       OBJPROP_XDISTANCE,info_x       );
         ObjectSet      (StringConcatenate(PREFIX, "FIVE_BARS"),       OBJPROP_YDISTANCE,info_y + 80      );

         ObjectCreate   (StringConcatenate(PREFIX, "SIX_BARS"),       OBJ_LABEL,        0, 0, 0  );
         ObjectSet      (StringConcatenate(PREFIX, "SIX_BARS"),       OBJPROP_CORNER,   info_corner    );
         ObjectSet      (StringConcatenate(PREFIX, "SIX_BARS"),       OBJPROP_XDISTANCE,info_x       );
         ObjectSet      (StringConcatenate(PREFIX, "SIX_BARS"),       OBJPROP_YDISTANCE,info_y + 100      );
     }
     
   return(0);
}

// DEINIT
int deinit()
{
   Comment("");
   DeleteCreatedObjects();
   //Print("Period() =", Period());
   return(0);
}

// START
int start()
{
   // loop
   int limit;
   int counted_bars = IndicatorCounted();
   if( counted_bars < 0 )
     {
         return(-1);
     }
   limit = Bars - counted_bars;
   // Main Calculation Loop
   for(  int i = MathMax ( limit - 8, 0 ); i >=0 ; i-- ) // back count
   {
      UP_ARROW[i] = 0;
      DOWN_ARROW[i] = 0;
      UP_LINE[i] = 0;
      DOWN_LINE[i] = 0;
      if( Filters_Apply )
         {
            RSI_0_0 = iRSI(Symbol(),0,RSI_Period,RSI_Appliedprice,i);
            RSI_1_0 = iRSI(Symbol(),0,RSI_Period,RSI_Appliedprice,i+RSI_Shift);
            STOCH_0_0 = iStochastic(Symbol(), 0, StochK, StochD, StochSlowing, StochMethod, StochPriceField, MODE_MAIN, i);
            RSI_0_1 = iRSI(Symbol(),0,RSI_Period,RSI_Appliedprice,i + 1);
            RSI_1_1 = iRSI(Symbol(),0,RSI_Period,RSI_Appliedprice,i+RSI_Shift + 1);
            STOCH_0_1 = iStochastic(Symbol(), 0, StochK, StochD, StochSlowing, StochMethod, StochPriceField, MODE_MAIN, i + 1);
            // current filter
            if((RSI_0_0 > RSI_Upper_level) && (RSI_1_0 <= RSI_Upper_level) && (STOCH_0_0 > StochLevel ))
              {
                  FILTER_ALLOW_BUY_CURRENT = true;
              }
            else
              {
                  FILTER_ALLOW_BUY_CURRENT = false;
              }
            if( (RSI_0_0 < RSI_Lower_level) && (RSI_1_0 >= RSI_Lower_level) && (STOCH_0_0 < StochLevel2 ) )
              {
                  FILTER_ALLOW_SELL_CURRENT = true;
              }
            else
              {
                  FILTER_ALLOW_SELL_CURRENT = false;
              }
            // previous filter
            if((RSI_0_1 > RSI_Upper_level) && (RSI_1_1 <= RSI_Upper_level) && (STOCH_0_1 > StochLevel ))
              {
                  FILTER_ALLOW_BUY_PREVIOUS = true;
              }
            else
              {
                  FILTER_ALLOW_BUY_PREVIOUS = false;
              }
            if( (RSI_0_1 < RSI_Lower_level) && (RSI_1_1 >= RSI_Lower_level) && (STOCH_0_1 < StochLevel2 ) )
              {
                  FILTER_ALLOW_SELL_PREVIOUS = true;
              }
            else
              {
                  FILTER_ALLOW_SELL_PREVIOUS = false;
              }
         }
      else
        {
            FILTER_ALLOW_BUY_CURRENT = true;
            FILTER_ALLOW_SELL_CURRENT = true;
            FILTER_ALLOW_BUY_PREVIOUS = true;
            FILTER_ALLOW_SELL_PREVIOUS = true;
        }
      int HIGHEST_BAR = iHighest ( NULL, 0, MODE_HIGH, HL_Bars, i + 1 );
      int LOWEST_BAR = iLowest ( NULL, 0, MODE_LOW, HL_Bars, i + 1 );
      double HIGHEST_VALUE = High[ HIGHEST_BAR ];
      double LOWEST_VALUE = Low[ LOWEST_BAR ];
      
      // upwards expected search for setup
      if( HIGHEST_BAR > LOWEST_BAR && FindPattern ( PatternMode, UPWARDS, i ) )
        {
            SETUP_PRICE_UP = Open [ i + 1 ];
            SETUP_TIME_UP = Time [ i + 2 ];
            PREVIOUS_SWING_UP = HIGHEST_VALUE;
            BARS_TO_PREVIOUS_SWING_UP = HIGHEST_BAR - i;
            // plot triangle
            double point_price = SETUP_PRICE_UP;
            double swing_price = PREVIOUS_SWING_UP;
            datetime start_time = Time[ i + BARS_TO_PREVIOUS_SWING_UP ] ;
            datetime middle_time = SETUP_TIME_UP;
            datetime end_time = middle_time + Period()*60*( BarsForwardOffset );
            //if( i >= BarsForwardOffset ) end_time = Time [ i - BarsForwardOffset + 2 ] ;
            //else end_time = iTime(Symbol(),Period(),0)+Period()*(BarsForwardOffset - 2)*60;
            if( Plot_Triangles )
              {
                  plotTriangle( 1, point_price, swing_price, start_time, middle_time, end_time ); 
              }
        }
      // check bars remaining
      int bars_difference_up = iBarShift( NULL, 0, SETUP_TIME_UP ) - i; // how many bars since last setup
      if( bars_difference_up <= BarsForwardOffset && bars_difference_up > BarsAllowedFrom )     // it still in range - then set UP_LINE indicator
        {
            double difference = PREVIOUS_SWING_UP - SETUP_PRICE_UP;
            double portion = difference / ( BARS_TO_PREVIOUS_SWING_UP + BarsForwardOffset - 2 );
            double value_up = PREVIOUS_SWING_UP - portion * ( BARS_TO_PREVIOUS_SWING_UP + bars_difference_up - 2 );
            UP_LINE[i] = value_up;
            if( bars_difference_up == 2 )
              {
                  value_up = PREVIOUS_SWING_UP - portion * ( BARS_TO_PREVIOUS_SWING_UP + bars_difference_up - 3 );
                  UP_LINE[i+1] = value_up;
              }
        }
      
      // downwards expected search for setup
      if(  LOWEST_BAR > HIGHEST_BAR && FindPattern ( PatternMode, DOWNWARDS, i ) )
        {
            SETUP_PRICE_DW = Open [ i + 1 ];
            SETUP_TIME_DW = Time [ i + 2 ];
            PREVIOUS_SWING_DW = LOWEST_VALUE;
            BARS_TO_PREVIOUS_SWING_DW = LOWEST_BAR - i;
            // plot triangle
            double point_price = SETUP_PRICE_DW;
            double swing_price = PREVIOUS_SWING_DW;
            datetime start_time = Time[ i + BARS_TO_PREVIOUS_SWING_DW ] ;
            datetime middle_time = SETUP_TIME_DW;
            datetime end_time = middle_time + Period()*60*( BarsForwardOffset );
            //end_time = middle_time + Period()*60*( BarsForwardOffset );//StringToTime
            //if( i > BarsForwardOffset ) end_time = Time [ i + 2 - BarsForwardOffset ] ;
            //else end_time = iTime( NULL, 0, i )+Period()*(BarsForwardOffset - 2)*60;
            if( Plot_Triangles )
              {
                  plotTriangle( -1, point_price, swing_price, start_time, middle_time, end_time ); 
              }
        }
      // check bars remaining for downwards
      int bars_difference_dw = iBarShift( NULL, 0, SETUP_TIME_DW ) - i; // how many bars since last setup
      if( bars_difference_dw <= BarsForwardOffset && bars_difference_dw > BarsAllowedFrom )     // it still in range - then set UP_LINE indicator
        {
            double difference = SETUP_PRICE_DW - PREVIOUS_SWING_DW;
            double portion = difference / ( BARS_TO_PREVIOUS_SWING_DW + BarsForwardOffset - 2 );
            double value_down = PREVIOUS_SWING_DW + portion * ( BARS_TO_PREVIOUS_SWING_DW + bars_difference_dw - 2 );
            DOWN_LINE[i] = value_down;
            if( bars_difference_dw == 2 )
              {
                  value_down = PREVIOUS_SWING_DW + portion * ( BARS_TO_PREVIOUS_SWING_DW + bars_difference_dw - 3 );
                  DOWN_LINE[i+1] = value_down;
              }
        }
        
      // arrows calculation if filter allows
         double current_open = Open[i];
         double current_close = Close[i];
         double prev_close = Close[i+1];
         double prev_open = Open[i+1];
         // up
         if( MEM_SETUP_TIME_UP != SETUP_TIME_UP )
           {
               double current_line_up = UP_LINE[i];
               double prev_line_up = UP_LINE[i+1];
               // current arrow
               if( i == 0 )
                 {
                     if( current_close > current_line_up && current_open < current_line_up && FILTER_ALLOW_BUY_CURRENT )
                       {
                           UP_ARROW[i] = Low[i] - arrow_offset * Point;
                       }
                 }
               // previous arrows crossings
               if( prev_line_up != 0 && current_line_up != 0 && prev_close > prev_line_up && prev_open < prev_line_up && FILTER_ALLOW_BUY_PREVIOUS )
                 {
                     UP_ARROW[i+1] = Low[i+1] - arrow_offset * Point;
                     MEM_SETUP_TIME_UP = SETUP_TIME_UP;
                 }
               if( prev_line_up != 0 && current_line_up != 0 && prev_close < prev_line_up && current_open > current_line_up && FILTER_ALLOW_BUY_PREVIOUS )
                 {
                     UP_ARROW[i+1] = Low[i+1] - arrow_offset * Point;
                     MEM_SETUP_TIME_UP = SETUP_TIME_UP;
                 }
           }
         
         // down
         if( MEM_SETUP_TIME_DW != SETUP_TIME_DW )
           {
               double current_line_dw = DOWN_LINE[i];
               double prev_line_dw = DOWN_LINE[i+1];
               // current arrow
               if( i == 0 )
                 {
                     if( current_close < current_line_dw && current_open > current_line_dw && FILTER_ALLOW_SELL_CURRENT )
                       {
                           DOWN_ARROW[i] = High[i] + arrow_offset * Point;
                       }
                 }
               // previous arrows crossings
               if( prev_line_dw != 0 && current_line_dw != 0 &&  prev_close < prev_line_dw && prev_open > prev_line_dw && FILTER_ALLOW_SELL_PREVIOUS )
                 {
                     DOWN_ARROW[i+1] = High[i+1] + arrow_offset * Point;
                     MEM_SETUP_TIME_DW = SETUP_TIME_DW;
                 }
               if( prev_line_dw != 0 && current_line_dw != 0 && prev_close > prev_line_dw && current_open < current_line_dw && FILTER_ALLOW_SELL_PREVIOUS )
                 {
                     DOWN_ARROW[i+1] = High[i+1] + arrow_offset * Point;
                     MEM_SETUP_TIME_DW = SETUP_TIME_DW;
                     if( runonce_1 )
                       {
                           runonce_1 = false;
                           //Print("RSI_0 = ", RSI_0);
                           //Print("RSI_1 = ", RSI_1);
                           //Print("STOCH_0 = ", STOCH_0);
                           //Print("Time = ", Time[i+1]);
                       }
                 }
           }
   }
   
   // ITM calculcate previous loop
   if( Draw_ITM_Label && runonce && Calculate_History )
     {
         for( int i = MathMax ( limit - 8, 0 ); i >= 1 ; i-- )
         {
            CalculateITMs( i, UP_ARROW, DOWN_ARROW);
         }
         runonce = false;
     }
   // ITM calculata current loop
   if( Draw_ITM_Label && NewBar( BarsForITMS) )
     {
         CalculateITMs( 1, UP_ARROW, DOWN_ARROW );
     }
   // Drawing ITM ratio stats
   if( Draw_ITM_Label )
     {
         DrawITMPanel();         
     }
    if( EnableAlert )
     {
         if( UP_ARROW[1] !=0 && NewBar() )
           {
               callAlert(CallMSG);
           }
         if( DOWN_ARROW[1] !=0 && NewBar() )
           {
               callAlert(PutMSG);
           }
     }
   return(0);
}

// USER FUNCS
void DeleteCreatedObjects()
{
   string obj_name;
   for(int i = ObjectsTotal() - 1 ; i >= 0; i-- )
     {
         obj_name = ObjectName(i);
         if( StringFind( obj_name, PREFIX, 0 ) != -1 )
           {
               ObjectDelete( obj_name );
           }
     }
}

bool NewBar()
{
   int currentBars = iBars( Symbol(), PERIOD_CURRENT );
   if( currentBars > BarsCount )
     {
         BarsCount = currentBars;
         return(true);
     }
   return(false);
}

bool NewBar( int &specific_counter)
{
   int currentBars = iBars( Symbol(), PERIOD_CURRENT );
   if( currentBars > specific_counter )
     {
         specific_counter = currentBars;
         return(true);
     }
   return(false);
}

bool  FindPattern( pattern Pattern, direction Direction, int shift )
{
   bool ans = false;
   switch(Pattern)
     {
      case 0:  // open-close engulf
        if( Direction == UPWARDS )
          {
            if( Open[ shift + 2 ] > Close[ shift + 2 ] && Open[ shift + 1 ] < Close[ shift + 1 ] && Close[ shift + 1 ] > Open[ shift + 2 ] && Open[ shift + 1 ] <= Close[ shift + 2 ] )
              {
                  ans = true;
              }
          }
        if( Direction == DOWNWARDS )
          {
            if( Open[ shift + 2 ] < Close[ shift + 2 ] && Open[ shift + 1 ] > Close[ shift + 1 ] && Close[ shift + 1 ] < Open[ shift + 2 ] && Open[ shift + 1 ] >= Close[ shift + 2 ] )
              {
                  ans = true;
              }
          }
      break;
      case 1: // tweezers
        if( Direction == UPWARDS )
          {
            if( Open[ shift + 2 ] > Close[ shift + 2 ] && Open[ shift + 1 ] < Close[ shift + 1 ] && Close[ shift + 1 ] > Open[ shift + 2 ] && Open[ shift + 1 ] <= Close[ shift + 2 ] )
              {
                  double body = Open[ shift + 2 ] - Close[ shift + 2 ];
                  double lower_wick = Close[ shift + 2 ] - Low[ shift + 2 ];
                  if( lower_wick >= body )
                    {
                        ans = true;   
                    }
              }
          }
        if( Direction == DOWNWARDS )
          {
            if( Open[ shift + 2 ] < Close[ shift + 2 ] && Open[ shift + 1 ] > Close[ shift + 1 ] && Close[ shift + 1 ] < Open[ shift + 2 ] && Open[ shift + 1 ] >= Close[ shift + 2 ] )
              {
                  double body = Close[ shift + 2 ] - Open[ shift + 2 ];
                  double upper_wick = High[ shift + 2 ] - Close[ shift + 2 ];
                  if( upper_wick >= body )
                    {
                        ans = true;   
                    }
              }
          }
      break;
      default:
      ans = false;
      break;
     }
   return(ans);
}

void callAlert(string message)
{
   Alert( StringConcatenate( PREFIX, " ", Symbol(), " TF = ", getPeriodString(Period()), " ", message ) );
}

string getPeriodString(int period_enum)
{
   switch(period_enum)
     {
      case  1:
      return("M1");
      break;
      case  5:
      return("M5");
      break;
      case  15:
      return("M15");
      break;
      case  30:
      return("M30");
      break;
      case  60:
      return("H1");
      break;
      case  240:
      return("H4");
      break;
      case  1440:
      return("D1");
      break;
      case  10080:
      return("W1");
      break;
      case  43200:
      return("MN1");
      break;
      default:
      return("ERROR#133");
      break;
     }
}

void plotTriangle ( int type, double point_price, double swing_price, datetime start_time, datetime middle_time, datetime end_time )
{
   
   string name1 = "";
   string name2 = "";
   color clr = clrNONE;
   int width = 0;
   int style = 0;
   switch( type )
     {
      case  1:
         name1 = StringConcatenate(PREFIX ,"_TR_UP_P_1_" , IntegerToString(TRIANGLE_UP_COUNTER++));
         name2 = StringConcatenate(PREFIX ,"_TR_UP_P_2_" , IntegerToString(TRIANGLE_UP_COUNTER++));
         clr = up_line_clr;
         width = up_line_width;
         style = up_line_style;
      break;
      case  -1:
         name1 = StringConcatenate(PREFIX ,"_TR_DW_P_1_" , IntegerToString(TRIANGLE_DW_COUNTER++));
         name2 = StringConcatenate(PREFIX ,"_TR_DW_P_2_" , IntegerToString(TRIANGLE_DW_COUNTER++));
         clr = dw_line_clr;
         width = dw_line_width;
         style = dw_line_style;
      break;
      default:
      break;
     }
   if( ObjectFind(name1) != -1 || ObjectFind(name2) != -1 )
     {
         return;
     }
   // create 1st segmented line
   ObjectCreate( name1, OBJ_TREND, 0, middle_time, point_price, end_time, point_price );
   ObjectSet( name1, OBJPROP_WIDTH, width );
   ObjectSet( name1, OBJPROP_STYLE, style );
   ObjectSet( name1, OBJPROP_RAY, false );
   ObjectSet( name1, OBJPROP_BACK, false );   // placing in front of candles
   ObjectSet( name1, OBJPROP_COLOR, clr );
   ObjectSet( name1, OBJPROP_SELECTABLE, false );
   // create 2nd segmented line
   ObjectCreate( name2, OBJ_TREND, 0, start_time, swing_price, end_time, point_price );
   ObjectSet( name2, OBJPROP_WIDTH, width );
   ObjectSet( name2, OBJPROP_STYLE, style );
   ObjectSet( name2, OBJPROP_RAY, false );
   ObjectSet( name2, OBJPROP_BACK, false );   // placing in front of candles
   ObjectSet( name2, OBJPROP_COLOR, clr );
   ObjectSet( name2, OBJPROP_SELECTABLE, false );
  /* ObjectCreate(name,OBJ_TREND,0,time1,value,time2,value);
   ObjectSet(name, OBJPROP_WIDTH, width);
   ObjectSet(name, OBJPROP_STYLE, style);
   ObjectSet(name, OBJPROP_RAY  , false);
   ObjectSet(name, OBJPROP_BACK , true);
   ObjectSet(name, OBJPROP_COLOR, clr);*/
}


void DrawITMPanel ()
{
      double WR_1 = ( (ITM_1 + OTM_1) == 0 )? 0 : (ITM_1 / (ITM_1 + OTM_1))*100;
      double WR_2 = ( (ITM_2 + OTM_2) == 0 )? 0 : (ITM_2 / (ITM_2 + OTM_2))*100;
      double WR_3 = ( (ITM_3 + OTM_3) == 0 )? 0 : (ITM_3 / (ITM_3 + OTM_3))*100;
      double WR_4 = ( (ITM_4 + OTM_4) == 0 )? 0 : (ITM_4 / (ITM_4 + OTM_4))*100;
      double WR_5 = ( (ITM_5 + OTM_5) == 0 )? 0 : (ITM_5 / (ITM_5 + OTM_5))*100;
      double WR_6 = ( (ITM_6 + OTM_6) == 0 )? 0 : (ITM_6 / (ITM_6 + OTM_6))*100;
      ObjectSetText( StringConcatenate(PREFIX, "ONE_BAR") , StringConcatenate("ONE BAR, WR% = ", DoubleToString( WR_1, 2), " ITM: ", ITM_1, " OTM: ", OTM_1 ), 10, "Arial Bold", clrLime );
      ObjectSetText( StringConcatenate(PREFIX, "TWO_BARS") , StringConcatenate("TWO BARS, WR% = ", DoubleToString( WR_2, 2), " ITM: ", ITM_2, " OTM: ", OTM_2 ), 10, "Arial Bold", clrLime );
      ObjectSetText( StringConcatenate(PREFIX, "THREE_BARS") , StringConcatenate("THREE BARS, WR% = ", DoubleToString( WR_3, 2), " ITM: ", ITM_3, " OTM: ", OTM_3 ), 10, "Arial Bold", clrLime );
      ObjectSetText( StringConcatenate(PREFIX, "FOUR_BARS") , StringConcatenate("FOUR BARS, WR% = ", DoubleToString( WR_4, 2), " ITM: ", ITM_4, " OTM: ", OTM_4 ), 10, "Arial Bold", clrLime );
      ObjectSetText( StringConcatenate(PREFIX, "FIVE_BARS") , StringConcatenate("FIVE BARS, WR% = ", DoubleToString( WR_5, 2), " ITM: ", ITM_5, " OTM: ", OTM_5 ), 10, "Arial Bold", clrLime );
      ObjectSetText( StringConcatenate(PREFIX, "SIX_BARS") , StringConcatenate("SIX BARS, WR% = ", DoubleToString( WR_6, 2), " ITM: ", ITM_6, " OTM: ", OTM_6 ), 10, "Arial Bold", clrLime );
}

void CalculateITMs( int index, double &CALL[], double &PUT[])
{
   double open_price;
   double close_price = Close[index];
   
   // 6 CALL
   if( CALL[index + 6] != 0 )
     {
         open_price = Open[index + 5];
         if( ComparePrices ( UPWARDS, open_price, close_price ) ) ITM_6++;
         else OTM_6++;
     }
   // 6 PUT
   if( PUT[index + 6] != 0 )
     {
         open_price = Open[index + 5];
         if( ComparePrices ( DOWNWARDS, open_price, close_price ) ) ITM_6++;
         else OTM_6++;
     }
   // 5 CALL
   if( CALL[index + 5] != 0 )
     {
         open_price = Open[index + 4];
         if( ComparePrices ( UPWARDS, open_price, close_price ) ) ITM_5++;
         else OTM_5++;
     }
   // 5 PUT
   if( PUT[index + 5] != 0 )
     {
         open_price = Open[index + 4];
         if( ComparePrices ( DOWNWARDS, open_price, close_price ) ) ITM_5++;
         else OTM_5++;
     }
   // 4 CALL
   if( CALL[index + 4] != 0 )
     {
         open_price = Open[index + 3];
         if( ComparePrices ( UPWARDS, open_price, close_price ) ) ITM_4++;
         else OTM_4++;
     }
   // 4 PUT
   if( PUT[index + 4] != 0 )
     {
         open_price = Open[index + 3];
         if( ComparePrices ( DOWNWARDS, open_price, close_price ) ) ITM_4++;
         else OTM_4++;
     }
   // 3 CALL
   if( CALL[index + 3] != 0 )
     {
         open_price = Open[index + 2];
         if( ComparePrices ( UPWARDS, open_price, close_price ) ) ITM_3++;
         else OTM_3++;
     }
   // 3 PUT
   if( PUT[index + 3] != 0 )
     {
         open_price = Open[index + 2];
         if( ComparePrices ( DOWNWARDS, open_price, close_price ) ) ITM_3++;
         else OTM_3++;
     }
   // 2 CALL
   if( CALL[index + 2] != 0 )
     {
         open_price = Open[index + 1];
         if( ComparePrices ( UPWARDS, open_price, close_price ) ) ITM_2++;
         else OTM_2++;
     }
   // 2 PUT
   if( PUT[index + 2] != 0 )
     {
         open_price = Open[index + 1];
         if( ComparePrices ( DOWNWARDS, open_price, close_price ) ) ITM_2++;
         else OTM_2++;
     }
   // 1 CALL
   if( CALL[index + 1] != 0 )
     {
         open_price = Open[index];
         if( ComparePrices ( UPWARDS, open_price, close_price ) ) ITM_1++;
         else OTM_1++;
     }
   // 1 PUT
   if( PUT[index + 1] != 0 )
     {
         open_price = Open[index];
         if( ComparePrices ( DOWNWARDS, open_price, close_price ) ) ITM_1++;
         else OTM_1++;
     }
}

bool ComparePrices ( direction _direction, double _open_price, double _close_price )
{
   bool ans = false;
   if( _direction == UPWARDS && _close_price > _open_price )
     {
         ans = true;
     }
   if( _direction == DOWNWARDS && _close_price < _open_price )
     {
         ans = true;
     }
   return (ans);
}